' ================================================================================================
'  Theremino System SLOTS operations - Bar Code
' ================================================================================================

Const BarcodeFirstSlot As Int32 = 500
Dim n1 As Single
Dim n2 As Single
Dim BarcodeText As String

' ------------------------------------------------------------------------------------------------
' This function is executed in a separate Thread - Do here slow and paused operations
' Questa funzione e' eseguita in un thread separato - Far qui le operazioni lente o con pause
' ------------------------------------------------------------------------------------------------ 
Sub PausableExecution()

	n1 = ReadSlot(BarcodeFirstSlot)
	n2 = ReadSlot(BarcodeFirstSlot + 1)

	' ------------------------------------------------- A code is arrived ?
	If n1 >=0 Then
	
		BarcodeText = n1.ToString
		WriteSlot(BarcodeFirstSlot, -1)
		If n2 >=0 Then
			BarcodeText &= n2.ToString
			WriteSlot(BarcodeFirstSlot + 1, -1)
		End If
		Label1.text = BarcodeText
		beep
		
		' --------------------------------------------- decode barcode
		Select Case BarcodeText
					
			Case "1"
				SoundPlayer_Play (10, 11, 0) ' SlotInput / SlotChange / SoundNumber(zero based)
			
			Case "2"
				SoundPlayer_Play (10, 11, 1) ' SlotInput / SlotChange / SoundNumber(zero based)
			
			Case "3"
				SoundPlayer_Play (10, 11, 2) ' SlotInput / SlotChange / SoundNumber(zero based)
				
			Case "4"
				SoundPlayer_Play (20, 21, 5) ' SlotInput / SlotChange / SoundNumber(zero based)
			
			Case Else
				Label2.text = "INVALID CODE"
				
		End Select
	End If

End Sub

Sub SoundPlayer_Play(SlotInput As Int32, SlotChange As Int32, SoundNumber As Int32)
	' --------------------------------------- CHANGE
	If SlotChange >= 0 Then
		WriteSlot(SlotChange, SoundNumber)
	End If
	' --------------------------------------- TRIGGER
	WriteSlot(SlotInput, 1000)
	PausaMs(100)
	WriteSlot(SlotInput, 0)
	' ---------------------------------------
	Label2.text = SlotInput.ToString & "  "  & SlotChange.ToString & "  "  & SoundNumber.ToString
End Sub




' ------------------------------------------------------------------------------------------------
' This function is executed 20 times per second (no pauses here or the whole program is locked)
' Funzione eseguita 20 volte al sec. ( niente pause qui altrimenti tutto il programma si blocca)
' ------------------------------------------------------------------------------------------------
Sub FastExecution
	' ---------------- questo esempio copia continuamente il valore dello slot 2 nello slot 3 
	' WriteSlot(3, ReadSlot(2))
	' ---------------- questo esempio copia il valore "invertito" dello slot 2 nello slot 3 
	' WriteSlot(3, 1000 - ReadSlot(2))
End Sub


' ------------------------------------------------------------------------------------------------
'  Functions called from user controls events
'  Queste funzioni vengono chiamate dagli eventi causati dai controlli utente
' ------------------------------------------------------------------------------------------------
'Sub TrackBar1_Scroll(value As Single)
'	Label2.Text = "E' stato mosso il cursore, il suo valore e': " & value.ToString("0")
'	WriteSlot(1, value)
'End Sub





' ================================================================================================
'  - ENG - THE SIMPLIFIED MANAGEMENT ENDS HER - MODIFY THE FOLLOWING CAREFULLY
' ------------------------------------------------------------------------------------------------
'  - ITA - LA GESTIONE SEMPLIFICATA FINISCE QUI - MODIFICARE LA PARTE SEGUENTE CON ATTENZIONE
' ================================================================================================


Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New form
	InitializeComponents
	MemoryMappedFile_Init
	StartThread
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Form1.Closing
	Timer1.Stop
	objThread.Abort
End Sub

Sub StartThread()
	' --------------------------------------------------------- asynchronously start the Thread 
	objThread = New Threading.Thread(AddressOf ExecuteThread)
	' --------------------------------------------------------- make the thread as background thread.
	objThread.IsBackground = True
	' --------------------------------------------------------- set the Priority of the thread.
	objThread.Priority = Threading.ThreadPriority.AboveNormal
	' --------------------------------------------------------- start the thread.
	objThread.Start()
End Sub

Sub ExecuteThread
	Do
		PausableExecution
		PausaMS(1)
	Loop Until False
End Sub

Sub PausaMS(ByVal mS As Int32)
	Threading.Thread.Sleep(mS)
End Sub

Sub Timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
	FastExecution
End Sub

Sub Button_Copy_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button_Copy.Click
	Clipboard.SetData(System.Windows.Forms.DataFormats.Text, Label1.text)
	beep
End Sub


' ---------------------------------------------------------------------- User Interface Components
WithEvents Form1 As Form
WithEvents Timer1 As Timer = New Timer
Dim objThread As Threading.Thread
Dim Label1 As Label = New Label
Dim Label2 As Label = New Label
WithEvents Button_Copy As Button = New Button

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - Bar Code"
	Form1.FormBorderStyle = FormBorderStyle.Fixed3D
	Form1.ClientSize = New System.Drawing.Size(500, 70)
	Form1.StartPosition = FormStartPosition.CenterScreen
	' ------------------------------------------------------------------ Label 1
	Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.Location = New Point(10, 10)
	Label1.Font = New Font("Arial", 12 )
	Label1.Size = New Size(320, 21)
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ Label 2
	Label2.BorderStyle = BorderStyle.Fixed3D
	Label2.Location = New Point(10, 40)
	Label2.Font = New Font("Arial", 12 )
	Label2.Size = New Size(320, 21)
	Form1.Controls.Add(Label2)	
	' ------------------------------------------------------------------ Button_Copy
	Label2.BorderStyle = BorderStyle.Fixed3D
	Button_Copy.Text = "Copy to clipboard"
	Button_Copy.Location = New Point(340, 10)
	Button_Copy.Font = New Font("Arial", 10 )
	Button_Copy.Size = New Size(150, 21)
	Form1.Controls.Add(Button_Copy)	
	' ------------------------------------------------------------------ Timer 1
	Timer1.Interval = 50
	Timer1.Start
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.show
End Sub

